'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var child = require('child_process');
var kleur = require('kleur');
var log = require('./log.js');
var os = require('./os.js');
var trimEnd = require('./trimEnd-0419335b.js');
require('./_tslib-05d1690a.js');
require('./home.js');
require('os');
require('./root.js');
require('./toString.js');
require('./type.js');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var child__default = /*#__PURE__*/_interopDefaultLegacy(child);
var kleur__default = /*#__PURE__*/_interopDefaultLegacy(kleur);

var separator = os["default"]() === 'windows'
    ? ' && '
    : '; ';
var info = function (type, message) {
    var msg = message.trim();
    if (!msg)
        return;
    msg = msg
        .replace(/\r/g, '\n')
        .replace(/\n{2,}/g, '');
    msg = type === 'error'
        ? kleur__default["default"].red(msg)
        : kleur__default["default"].gray(msg);
    console.log(msg);
};
var main = function (cmd, option) {
    if (option === void 0) { option = {}; }
    var stringCmd = cmd instanceof Array
        ? cmd.join(separator)
        : cmd;
    var _a = os["default"]() === 'macos'
        ? ['/bin/sh', ['-c', stringCmd]]
        : ['cmd.exe', ['/s', '/c', stringCmd]], cmder = _a[0], arg = _a[1];
    if (!option.silent)
        log["default"]('exec', stringCmd);
    return new Promise(function (resolve) {
        var result = '';
        var process = child__default["default"].spawn(cmder, arg, {});
        process.stderr.on('data', function (data) {
            result = parseMessage(data);
            if (!option.silent)
                info('error', data.toString());
        });
        process.stdout.on('data', function (data) {
            result = parseMessage(data);
            if (!option.silent)
                info('default', data.toString());
        });
        process.on('close', function (code) {
            if (code === 0 || option.ignoreError)
                resolve([true, result]);
            resolve([false, result]);
        });
    });
};
var parseMessage = function (buffer) { return trimEnd.trimEnd_1(buffer.toString(), '\n'); };

exports["default"] = main;
