/// <reference types="node" />
/// <reference types="node" />
declare const $: {
    argv: <T extends Record<string, unknown>>() => T & {
        [x: string]: unknown;
        _: (string | number)[];
        $0: string;
    };
    backup: (source: string | string[]) => Promise<void>;
    clean: (source: string | string[]) => Promise<void>;
    copy: (source: string | string[], target: string, name?: string | undefined) => Promise<void>;
    download: (source: string, target: string, option?: string | Partial<import("./download").Option>) => Promise<void>;
    exec: (cmd: string | string[], option?: {
        ignoreError?: boolean | undefined;
        silent?: boolean | undefined;
    }) => Promise<[boolean, string]>;
    getBasename: (input: string) => string;
    getDirname: (input: string) => string;
    getExtname: (input: string) => string;
    getFilename: (input: string) => string;
    getName: (input: string) => {
        basename: string;
        dirname: string;
        extname: string;
        filename: string;
    };
    glob: (input: string | string[] | (string[] & {
        __is_listed_as_source__: true;
    }), options?: import("fast-glob/out/settings").Options | undefined) => Promise<string[] & {
        __is_listed_as_source__: true;
    }>;
    home: () => string;
    isExisted: (source: string | string[]) => Promise<boolean>;
    isSame: (source: string | string[]) => Promise<boolean>;
    link: (source: string, target: string) => Promise<void>;
    log: {
        <T_1>(...args: [T_1] | [string, T_1]): T_1;
        freeze: <T_2>(callback: Promise<T_2> | (() => Promise<T_2>)) => Promise<T_2>;
        isFrozen: boolean;
        isSilent: boolean;
        pause: () => void;
        resume: () => void;
        whisper: <T_3>(callback: Promise<T_3> | (() => Promise<T_3>)) => Promise<T_3>;
    };
    mkdir: (source: string | string[]) => Promise<void>;
    normalizePath: (source: string) => string;
    os: () => "" | "macos" | "unknown" | "windows";
    prompt: <T_4, U extends "number" | "auto" | "confirm" | "multi" | "select" | "text" | "toggle" = "number" | "auto" | "confirm" | "multi" | "select" | "text" | "toggle">(option: (U extends "confirm" ? {
        type: "number" | "auto" | "confirm" | "multi" | "select" | "text" | "toggle";
        id?: string | undefined;
        message?: string | undefined;
    } & {
        type: "confirm";
        default?: boolean | undefined;
    } : U extends "number" ? {
        type: "number" | "auto" | "confirm" | "multi" | "select" | "text" | "toggle";
        id?: string | undefined;
        message?: string | undefined;
    } & {
        type: "number";
        default?: number | undefined;
        max: number;
        min: number;
    } : U extends "auto" | "multi" | "select" ? {
        type: "number" | "auto" | "confirm" | "multi" | "select" | "text" | "toggle";
        id?: string | undefined;
        message?: string | undefined;
    } & {
        type: "auto" | "multi" | "select";
        default?: string | number | undefined;
        list: (T_4 | {
            title: string;
            description?: string | undefined;
            value: T_4;
            disabled?: boolean | undefined;
        })[];
    } : U extends "text" ? {
        type: "number" | "auto" | "confirm" | "multi" | "select" | "text" | "toggle";
        id?: string | undefined;
        message?: string | undefined;
    } & {
        type: "text";
        default?: string | undefined;
    } : U extends "toggle" ? {
        type: "number" | "auto" | "confirm" | "multi" | "select" | "text" | "toggle";
        id?: string | undefined;
        message?: string | undefined;
    } & {
        type: "toggle";
        default?: boolean | undefined;
        off?: string | undefined;
        on?: string | undefined;
    } : never) & {
        list?: (T_4 | {
            title: string;
            description?: string | undefined;
            value: T_4;
            disabled?: boolean | undefined;
        })[] | undefined;
        type: U;
    }) => Promise<T_4 & (U extends "confirm" ? boolean : U extends "number" ? number : U extends "auto" | "multi" | "select" ? T_4 : U extends "text" ? string : U extends "toggle" ? boolean : never)>;
    read: <T_5 = undefined, S extends string = string, R extends boolean = false>(source: S, options?: {
        raw: R;
    } | undefined) => Promise<T_5 extends undefined ? R extends true ? Buffer | undefined : (S extends `${string}.coffee` | `${string}.css` | `${string}.html` | `${string}.js` | `${string}.md` | `${string}.pug` | `${string}.sh` | `${string}.styl` | `${string}.ts` | `${string}.tsx` | `${string}.txt` | `${string}.xml` ? string : S extends `${string}.json` | `${string}.yaml` | `${string}.yml` ? {
        [x: string]: unknown;
    } : Buffer) | undefined : T_5>;
    recover: (source: string | string[]) => Promise<void>;
    remove: (source: string | string[]) => Promise<void>;
    rename: (source: string, target: string) => Promise<void>;
    root: () => string;
    say: (text: string, option?: {
        lang?: "ja" | "ja-jp" | "zh" | "zh-cn" | "zh-hk" | "zh-tw" | undefined;
        voice?: "kyoko" | "ting-ting" | "sin-ji" | "mei-jia" | undefined;
    }) => Promise<void>;
    sleep: (delay?: number) => Promise<void>;
    stat: (source: string) => Promise<import("fs").Stats | null>;
    toArray: <T_6>(input: T_6 | T_6[]) => T_6[];
    toDate: (input: string | number | Date) => Date;
    toJson: (input: unknown) => Record<string, unknown> | unknown[];
    toString: (input: unknown) => string;
    type: (input: unknown) => string;
    watch: (listSource: string | string[], callback: (path: string) => void, options?: {
        debounce?: number | undefined;
    }) => void;
    wrapList: (input: unknown) => string;
    write: (source: string, content: unknown, options?: import("fs-extra").WriteFileOptions | undefined) => Promise<boolean>;
    zip: (source: string | string[], target?: string, option?: string | {
        base?: string | undefined;
        filename?: string | undefined;
    }) => Promise<void>;
};
export default $;
