declare type Choice<T> = {
    title: string;
    description?: string;
    value: T;
    disabled?: boolean;
};
declare type List<T> = (T | Choice<T>)[];
declare type Option<T extends Type, U> = T extends 'confirm' ? OptionConfirm : T extends 'number' ? OptionNumber : T extends 'auto' | 'multi' | 'select' ? OptionSelect<U> : T extends 'text' ? OptionText : T extends 'toggle' ? OptionToggle : never;
declare type OptionConfirm = OptionGeneral & {
    type: 'confirm';
    default?: boolean;
};
declare type OptionGeneral = {
    type: Type;
    id?: string;
    message?: string;
};
declare type OptionNumber = OptionGeneral & {
    type: 'number';
    default?: number;
    max: number;
    min: number;
};
declare type OptionSelect<T> = OptionGeneral & {
    type: 'auto' | 'multi' | 'select';
    default?: number | string;
    list: List<T>;
};
declare type OptionText = OptionGeneral & {
    type: 'text';
    default?: string;
};
declare type OptionToggle = OptionGeneral & {
    type: 'toggle';
    default?: boolean;
    off?: string;
    on?: string;
};
declare type Result<T extends Type = Type, U = unknown> = T extends 'confirm' ? boolean : T extends 'number' ? number : T extends 'auto' | 'multi' | 'select' ? U : T extends 'text' ? string : T extends 'toggle' ? boolean : never;
declare type Type = typeof listType[number];
declare const listType: readonly ["auto", "confirm", "multi", "number", "select", "text", "toggle"];
declare const main: <T, U extends "number" | "auto" | "confirm" | "multi" | "select" | "text" | "toggle" = "number" | "auto" | "confirm" | "multi" | "select" | "text" | "toggle">(option: Option<U, T> & {
    list?: List<T> | undefined;
    type: U;
}) => Promise<T & Result<U, T>>;
export default main;
